/* FILE: thermalms.h                        -*-Mode: c++-*-
 *
 * Non-abstract child of Oxs_StateInitializer that adjusts
 * ptwise saturation magnetization (Ms) between steps.
 *
 */

#ifndef _OXS_THERMALMS
#define _OXS_THERMALMS

#include "stateinitializer.h"

/* End includes */

class Oxs_ThermalMs : public Oxs_StateInitializer {
 public:
  Oxs_ThermalMs
  ( const char* name,        // Child instance id
    Oxs_Director* newdtr,    // App director
    const char* argstr       // Args
    ) : Oxs_StateInitializer(name,newdtr,argstr) {}

  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.

  virtual void InitState(Oxs_SimState& new_state);

 private:
  // Disable implicit constructors and assignment operator
  Oxs_ThermalMs() = delete;
  Oxs_ThermalMs(const Oxs_ThermalMs&) = delete;
  Oxs_ThermalMs& operator=(const Oxs_ThermalMs&) = delete;
};

#endif // _OXS_THERMALMS
